/*
 * JBoss, the OpenSource EJB server
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */

import org.jboss.aop.Aspect;
import org.jboss.aop.Mixin;
import org.jboss.aop.Introduction;

/**
 * @author <a href="mailto:kabir.khan@jboss.org">Kabir Khan</a>
 * @version $Revision: 1.1 $
 */
@Aspect
public class MyAspect
{
   @Introduction (target=POJO.class, interfaces={java.io.Serializable.class})
   public static Object noInterfacesPOJOIntro;

   @Mixin (target=POJO2.class, interfaces={java.io.Externalizable.class})
   public static POJO2ExternalizableMixin createExternalizableMixin(POJO2 pojo) {
       return new POJO2ExternalizableMixin(pojo);
   }

   @Introduction (typeExpression="class(POJO3) OR class(POJO4)", interfaces={java.io.Serializable.class})
   public static Object withTypeExpression;

}
