/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */

import org.jboss.aop.Advisor;
import org.jboss.aop.InstanceAdvisor;
import org.jboss.aop.joinpoint.Invocation;
import org.jboss.aop.joinpoint.Joinpoint;
import org.jboss.aop.advice.Interceptor;

/**
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.1 $
 */
public class ConfigInterceptor implements Interceptor
{
   String attr1;
   int attr2;
   Advisor advisor;
   InstanceAdvisor instanceAdvisor;
   Joinpoint jp;

   public void setAttr1(String s)
   {
      attr1 = s;
      System.out.println("setAttr1: " + s);
   }
      
   public void setAttr2(int i)
   {
      attr2 = i;
      System.out.println("setAttr2: " + i);
   }

   public void setMyAdvisor(Advisor advisor)
   {
      this.advisor = advisor;
   }
   
   public void setMyInstanceAdvisor(InstanceAdvisor instanceAdvisor)
   {
      this.instanceAdvisor = instanceAdvisor;
   }
   
   public void setMyJoinpoint(Joinpoint jp)
   {
      this.jp = jp;
   }

   public String getName() { return "ConfigInterceptor"; }

   public Object invoke(Invocation invocation) throws Throwable
   {
      try
      {
         System.out.println("<<< Entering ConfigInterceptor type: " + this);
         System.out.println("      attr1:" + attr1 + "; attr2:" + attr2);
	      System.out.println("      has advisor: " + (advisor != null));
	      System.out.println("      has instanceAdvisor: " + (instanceAdvisor != null));
	      System.out.println("      has joinpoint: " + (jp != null));
         
         return invocation.invokeNext();
      }
      finally
      {
         System.out.println(">>> Leaving ConfigInterceptor");
      }
   }
}
