import org.jboss.aop.InstanceAdvised;
import org.jboss.aop.Advised;
import org.jboss.aop.advice.AdviceBinding;
import org.jboss.aop.AspectManager;

public class Driver
{
   public static void main(String[] args) throws Exception
   {
      execute();
      AdviceBinding binding = new AdviceBinding("execution(POJO->new(..))", null);
      binding.addInterceptor(SimpleInterceptor.class);
      AspectManager.instance().addBinding(binding);
      execute();
   }
   public static void execute()
   {
      System.out.println("--- new POJO(); ---");
      POJO pojo = new POJO();
      System.out.println("--- adding instance interceptors ---");
      Advised advised = (Advised)pojo;
      advised._getInstanceAdvisor().insertInterceptor(new InstanceInterceptor());
      System.out.println("--- pojo.counter++; ---");
      pojo.counter++;
      System.out.println("--- pojo.someMethod(); ---");
      pojo.someMethod();
   }
}
