/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */

import org.jboss.aop.joinpoint.Invocation;
import org.jboss.aop.joinpoint.FieldWriteInvocation;
import org.jboss.aop.advice.Interceptor;

/**
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.3 $
 */
public class SetInterceptor implements Interceptor
{
   public String getName() { return "SetInterceptor"; }

   public Object invoke(Invocation invocation) throws Throwable
   {
      if (!(invocation instanceof FieldWriteInvocation)) return invocation.invokeNext();
      try
      {
         FieldWriteInvocation mi = (FieldWriteInvocation)invocation;
         System.out.println("<<< Entering SetInterceptor for: " + mi.getField().getName());
         return invocation.invokeNext();
      }
      finally
      {
         System.out.println(">>> Leaving SetInterceptor");
      }
   }
}
