/*
 * JBoss, the OpenSource J2EE webOS
 *
 * Distributable under LGPL license.
 * See terms of license at gnu.org.
 */

import org.jboss.aop.joinpoint.Invocation;
import org.jboss.aop.joinpoint.MethodInvocation;
import org.jboss.aop.advice.Interceptor;

/**
 *
 * @author <a href="mailto:bill@jboss.org">Bill Burke</a>
 * @version $Revision: 1.2 $
 */
public class MethodInterceptor implements Interceptor
{
   public String getName() { return "MethodInterceptor"; }

   public Object invoke(Invocation invocation) throws Throwable
   {
      try
      {
         MethodInvocation mi = (MethodInvocation)invocation;
         System.out.println("<<< Entering MethodInterceptor for: " + mi.getMethod().toString());
         return invocation.invokeNext();
      }
      finally
      {
         System.out.println(">>> Leaving MethodInterceptor");
      }
   }
}
